searchData={"items":[{"type":"module","title":"Membrane.RTSP","doc":"Functions for interfacing with a RTSP session","ref":"Membrane.RTSP.html"},{"type":"function","title":"Membrane.RTSP.announce/3","doc":"","ref":"Membrane.RTSP.html#announce/3"},{"type":"function","title":"Membrane.RTSP.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Membrane.RTSP.html#child_spec/1"},{"type":"function","title":"Membrane.RTSP.close/1","doc":"","ref":"Membrane.RTSP.html#close/1"},{"type":"function","title":"Membrane.RTSP.describe/2","doc":"","ref":"Membrane.RTSP.html#describe/2"},{"type":"function","title":"Membrane.RTSP.get_parameter/3","doc":"","ref":"Membrane.RTSP.html#get_parameter/3"},{"type":"function","title":"Membrane.RTSP.get_parameter_no_response/3","doc":"","ref":"Membrane.RTSP.html#get_parameter_no_response/3"},{"type":"function","title":"Membrane.RTSP.get_socket/1","doc":"","ref":"Membrane.RTSP.html#get_socket/1"},{"type":"function","title":"Membrane.RTSP.handle_response/2","doc":"","ref":"Membrane.RTSP.html#handle_response/2"},{"type":"function","title":"Membrane.RTSP.options/2","doc":"","ref":"Membrane.RTSP.html#options/2"},{"type":"function","title":"Membrane.RTSP.pause/2","doc":"","ref":"Membrane.RTSP.html#pause/2"},{"type":"function","title":"Membrane.RTSP.play/2","doc":"","ref":"Membrane.RTSP.html#play/2"},{"type":"function","title":"Membrane.RTSP.play_no_response/2","doc":"","ref":"Membrane.RTSP.html#play_no_response/2"},{"type":"function","title":"Membrane.RTSP.record/2","doc":"","ref":"Membrane.RTSP.html#record/2"},{"type":"function","title":"Membrane.RTSP.request/5","doc":"","ref":"Membrane.RTSP.html#request/5"},{"type":"function","title":"Membrane.RTSP.request_no_response/5","doc":"","ref":"Membrane.RTSP.html#request_no_response/5"},{"type":"function","title":"Membrane.RTSP.set_parameter/3","doc":"","ref":"Membrane.RTSP.html#set_parameter/3"},{"type":"function","title":"Membrane.RTSP.setup/3","doc":"","ref":"Membrane.RTSP.html#setup/3"},{"type":"function","title":"Membrane.RTSP.start/2","doc":"Same as start_link/2, but doesn't link the session process.","ref":"Membrane.RTSP.html#start/2"},{"type":"function","title":"Membrane.RTSP.start_link/2","doc":"Starts and links session process with given URL as a base path for requests.","ref":"Membrane.RTSP.html#start_link/2"},{"type":"function","title":"Membrane.RTSP.teardown/2","doc":"","ref":"Membrane.RTSP.html#teardown/2"},{"type":"function","title":"Membrane.RTSP.transfer_socket_control/2","doc":"","ref":"Membrane.RTSP.html#transfer_socket_control/2"},{"type":"function","title":"Membrane.RTSP.user_agent/0","doc":"","ref":"Membrane.RTSP.html#user_agent/0"},{"type":"type","title":"Membrane.RTSP.headers/0","doc":"","ref":"Membrane.RTSP.html#t:headers/0"},{"type":"type","title":"Membrane.RTSP.option/0","doc":"","ref":"Membrane.RTSP.html#t:option/0"},{"type":"type","title":"Membrane.RTSP.options/0","doc":"","ref":"Membrane.RTSP.html#t:options/0"},{"type":"type","title":"Membrane.RTSP.t/0","doc":"","ref":"Membrane.RTSP.html#t:t/0"},{"type":"module","title":"Membrane.RTSP.Request","doc":"This module represents a RTSP 1.0 request.","ref":"Membrane.RTSP.Request.html"},{"type":"function","title":"Membrane.RTSP.Request.get_header/2","doc":"Retrieves the first header matching given name from a request.\n\n```\n  iex> request = %Request{\n  ...>   method: \"OPTIONS\",\n  ...>   headers: [{\"header_name\", \"header_value\"}]\n  ...> }\n  iex> Request.get_header(request, \"header_name\")\n  {:ok, \"header_value\"}\n  iex> Request.get_header(request, \"non_existent_header\")\n  {:error, :no_such_header}\n\n```","ref":"Membrane.RTSP.Request.html#get_header/2"},{"type":"function","title":"Membrane.RTSP.Request.parse/1","doc":"Parse a binary request into RTSP Request struct\n\n```\n  iex> Request.parse(\"DESCRIBE rtsp://domain.net:554/path:movie.mov RTSP/1.0\\r\\n\\r\\n\")\n  {:ok, %Request{method: \"DESCRIBE\", path: \"rtsp://domain.net:554/path:movie.mov\", headers: [], body: nil}}\n\n  iex> Request.parse(\"DESCRIBE rtsp://domain.net:554/path:movie.mov RTSP/1.0\\r\\nCSeq: 1\\r\\n\\r\\n\")\n  {:ok, %Request{method: \"DESCRIBE\", path: \"rtsp://domain.net:554/path:movie.mov\", headers: [{\"CSeq\", \"1\"}], body: nil}}\n\n  iex> Request.parse(\"DESCRIBE rtsp://domain.net:554/path:movie.mov RTSP/1.0\\r\\nContent-Length: 11\\r\\n\\r\\nHello World\")\n  {:ok, %Request{method: \"DESCRIBE\", path: \"rtsp://domain.net:554/path:movie.mov\", headers: [{\"Content-Length\", \"11\"}], body: \"Hello World\"}}\n\n  iex> Request.parse(\"DESCRIBE rtsp://domain.net:554/path:movie.mov RTSP/1.1\\r\\n\\r\\n\")\n  {:error, \"expected string \\\"RTSP/1.0\\\"\"}\n\n```","ref":"Membrane.RTSP.Request.html#parse/1"},{"type":"function","title":"Membrane.RTSP.Request.parse_transport_header/1","doc":"Parse the Transport header.\n\n```\n  iex> req = %Request{method: \"SETUP\", headers: [{\"Transport\", \"RTP/AVP;unicast;client_port=30001-30002\"}]}\n  iex> Request.parse_transport_header(req)\n  {:ok, [transport: :UDP, mode: :unicast, parameters: %{\"client_port\" => {30001, 30002}}]}\n\n  iex> req = %Request{method: \"SETUP\", headers: [{\"Transport\", \"RTP/AVP;ttl=15\"}]}\n  iex> Request.parse_transport_header(req)\n  {:ok, [transport: :UDP, mode: :multicast, parameters: %{\"ttl\" => 15}]}\n\n  iex> req = %Request{method: \"SETUP\", headers: [{\"Transport\", \"RTP/AVP/TCP;unicast;interleaved=0-1\"}]}\n  iex> Request.parse_transport_header(req)\n  {:ok, [transport: :TCP, mode: :unicast, parameters: %{\"interleaved\" => {0, 1}}]}\n\n  iex> req = %Request{method: \"SETUP\", headers: [{\"Transport\", \"RTP/AVP\"}]}\n  iex> Request.parse_transport_header(req)\n  {:ok, [transport: :UDP, mode: :multicast, parameters: %{}]}\n\n  iex> req = %Request{method: \"SETUP\", headers: [{\"Transport\", \"RTP/AV\"}]}\n  iex> Request.parse_transport_header(req)\n  {:error, :invalid_header}\n\n  iex> Request.parse_transport_header(%Request{method: \"SETUP\"})\n  {:error, :no_such_header}\n\n```","ref":"Membrane.RTSP.Request.html#parse_transport_header/1"},{"type":"function","title":"Membrane.RTSP.Request.process_uri/2","doc":"Returns the encoded URI as a binary. This is handy for\ndigest auth since this value must be encoded as per the digest\nalgorithm","ref":"Membrane.RTSP.Request.html#process_uri/2"},{"type":"function","title":"Membrane.RTSP.Request.stringify/2","doc":"Renders the a RTSP request struct into a binary that is a valid\nRTSP request string that can be transmitted via communication channel.\n\n```\niex> uri = URI.parse(\"rtsp://domain.net:554/path:movie.mov\")\niex> Request.stringify(%Request{method: \"DESCRIBE\"}, uri)\n\"DESCRIBE rtsp://domain.net:554/path:movie.mov RTSP/1.0\\r\\n\\r\\n\"\niex> Request.stringify(%Request{method: \"PLAY\", path: \"trackID=2\"}, uri)\n\"PLAY rtsp://domain.net:554/path:movie.mov/trackID=2 RTSP/1.0\\r\\n\\r\\n\"\niex> Request.stringify(%Request{method: \"SET_PARAMETER\", body: \"parameter:value\"}, uri)\n\"SET_PARAMETER rtsp://domain.net:554/path:movie.mov RTSP/1.0\\r\\n\\r\\nparameter:value\"\n\n```\n\nAccess credentials won't be rendered into an url present in a RTSP start line.\n\n```\niex> uri = URI.parse(\"rtsp://user:password@domain.net:554/path:movie.mov\")\niex> Request.stringify(%Request{method: \"DESCRIBE\"}, uri)\n\"DESCRIBE rtsp://domain.net:554/path:movie.mov RTSP/1.0\\r\\n\\r\\n\"\n\n```","ref":"Membrane.RTSP.Request.html#stringify/2"},{"type":"function","title":"Membrane.RTSP.Request.with_header/3","doc":"Attaches a header to a RTSP request struct.\n\n```\n  iex> Request.with_header(%Request{method: \"DESCRIBE\"}, \"header_name\", \"header_value\")\n  %Request{method: \"DESCRIBE\", headers: [{\"header_name\",\"header_value\"}]}\n\n```","ref":"Membrane.RTSP.Request.html#with_header/3"},{"type":"type","title":"Membrane.RTSP.Request.t/0","doc":"","ref":"Membrane.RTSP.Request.html#t:t/0"},{"type":"type","title":"Membrane.RTSP.Request.transport_header/0","doc":"","ref":"Membrane.RTSP.Request.html#t:transport_header/0"},{"type":"module","title":"Membrane.RTSP.Response","doc":"This module represents a RTSP response.","ref":"Membrane.RTSP.Response.html"},{"type":"function","title":"Membrane.RTSP.Response.get_header/2","doc":"Retrieves the first header matching given name from a response.\n\n```\n  iex> response = %Response{\n  ...>   status: 200,\n  ...>   version: \"1.0\",\n  ...>   headers: [{\"header_name\", \"header_value\"}]\n  ...> }\n  iex> Response.get_header(response, \"header_name\")\n  {:ok, \"header_value\"}\n  iex> Response.get_header(response, \"non_existent_header\")\n  {:error, :no_such_header}\n\n```","ref":"Membrane.RTSP.Response.html#get_header/2"},{"type":"function","title":"Membrane.RTSP.Response.new/1","doc":"","ref":"Membrane.RTSP.Response.html#new/1"},{"type":"function","title":"Membrane.RTSP.Response.ok?/1","doc":"Returns true if the response is a success.\n\n```\n  iex> Response.ok?(Response.new(204))\n  true\n\n  iex> Response.ok?(Response.new(400))\n  false\n\n```","ref":"Membrane.RTSP.Response.html#ok?/1"},{"type":"function","title":"Membrane.RTSP.Response.parse/1","doc":"Parses RTSP response.\n\nIf the body is present it will be parsed according to `Content-Type` header.\nCurrently only the `application/sdp` is supported.","ref":"Membrane.RTSP.Response.html#parse/1"},{"type":"function","title":"Membrane.RTSP.Response.stringify/1","doc":"Renders an RTSP response struct into a binary that is a valid\nRTSP response string that can be transmitted via communication channel.\n\n```\n  iex> Response.stringify(%Response{version: \"1.0\", status: 200, headers: []})\n  \"RTSP/1.0 200 OK\\r\\n\\r\\n\"\n\n  iex> Response.stringify(%Response{version: \"1.0\", status: 200, headers: [{\"Content-Length\", \"11\"}, {\"Session\", \"15569\"}], body: \"Hello World\"})\n  \"RTSP/1.0 200 OK\\r\\nContent-Length: 11\\r\\nSession: 15569\\r\\n\\r\\nHello World\"\n\n```","ref":"Membrane.RTSP.Response.html#stringify/1"},{"type":"function","title":"Membrane.RTSP.Response.verify_content_length/1","doc":"Verifies if raw response binary has got proper length by comparing `Content-Length` header value to actual size of body in response.\nReturns tuple with verdict, expected size and actual size of body\n\nExample responses:\n`{:ok, 512, 512}` - `Content-Length` header value and body size matched. A response is complete.\n`{:ok, 0, 0}` - `Content-Length` header missing or set to 0 and no body. A response is complete.\n`{:error, 512, 123}` - Missing part of body in response.\n`{:error, 512, 623}` - Body in response longer than expected.\n`{:error, 512, 0}` - Missing whole body in response.\n`{:error, 0, 123}` - Body is present despite not being expected.\n`{:error, 0, 0}` - Missing part of header or missing delimiter at the end of the header part.","ref":"Membrane.RTSP.Response.html#verify_content_length/1"},{"type":"function","title":"Membrane.RTSP.Response.with_body/2","doc":"Adds a body to the response and sets `Content-Length` header\n\n```\n  iex> Response.with_body(Response.new(200), \"Hello World\")\n  %Response{version: \"1.0\", status: 200, headers: [{\"Content-Length\", \"11\"}], body: \"Hello World\"}\n\n```","ref":"Membrane.RTSP.Response.html#with_body/2"},{"type":"function","title":"Membrane.RTSP.Response.with_header/3","doc":"Attaches a header to a RTSP response struct.\n\n```\n  iex> Response.with_header(Response.new(200), \"header_name\", \"header_value\")\n  %Response{version: \"1.0\", status: 200, headers: [{\"header_name\",\"header_value\"}]}\n\n```","ref":"Membrane.RTSP.Response.html#with_header/3"},{"type":"type","title":"Membrane.RTSP.Response.result/0","doc":"","ref":"Membrane.RTSP.Response.html#t:result/0"},{"type":"type","title":"Membrane.RTSP.Response.t/0","doc":"","ref":"Membrane.RTSP.Response.html#t:t/0"},{"type":"module","title":"Membrane.RTSP.Server","doc":"Implementation of an RTSP server.","ref":"Membrane.RTSP.Server.html"},{"type":"module","title":"Usage - Membrane.RTSP.Server","doc":"To use the RTSP server, you should start it and provide some configuration. To start a new server\nunder a supervision tree:\n```\nchildren = [\n  {Membrane.RTSP.Server, [port: 8554, handler: MyRequestHandler]}\n]\n\nSupervisor.start_link(children, strategy: :one_for_one)\n```\n\nOr start it directly by calling `start_link/1` or `start/1`.\n\n```\n{:ok, server} = Membrane.RTSP.Server.start_link(config)\n```\n\nFor the available configuration options refer to `start_link/1`","ref":"Membrane.RTSP.Server.html#module-usage"},{"type":"function","title":"Membrane.RTSP.Server.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Membrane.RTSP.Server.html#child_spec/1"},{"type":"function","title":"Membrane.RTSP.Server.port_number/1","doc":"Get the port number of the server.\n\nIf the server started with port number 0, the os will choose an available port to\nassign to the server.","ref":"Membrane.RTSP.Server.html#port_number/1"},{"type":"function","title":"Membrane.RTSP.Server.start/1","doc":"Start an instance of the RTSP server.\n\nRefer to `start_link/1` for the available configuration.","ref":"Membrane.RTSP.Server.html#start/1"},{"type":"function","title":"Membrane.RTSP.Server.start_link/1","doc":"Start and link an instance of the RTSP server.","ref":"Membrane.RTSP.Server.html#start_link/1"},{"type":"function","title":"Options - Membrane.RTSP.Server.start_link/1","doc":"- `handler` - An implementation of the behaviour `Membrane.RTSP.Server.Handler`. Refer to the module\n  documentation for more details. This field is required.\n  - `name` - Used for name registration of the server. Defaults to `nil`.\n  - `port` - The port where the server will listen for client connections. Defaults to: `554`\n  - `address` - Specify the address where the `tcp` and `udp` sockets will be bound. Defaults to `:any`.\n  - `udp_rtp_port` - The port number of the `UDP` socket that will be opened to send `RTP` packets.\n  - `udp_rtcp_port` - The port number of the `UDP` socket that will be opened to send `RTCP` packets.\n  - `session_timeout` - if the server does not receive any request from the client within the specified\n    timeframe (in seconds), the connection will be closed. Defaults to 60 seconds.\n\n  > #### `Server UDP support` {: .warning}\n  >\n  > Both `udp_rtp_port` and `udp_rtcp_port` must be provided for the server\n  > to support `UDP` transport.","ref":"Membrane.RTSP.Server.html#start_link/1-options"},{"type":"type","title":"Membrane.RTSP.Server.server_config/0","doc":"","ref":"Membrane.RTSP.Server.html#t:server_config/0"},{"type":"behaviour","title":"Membrane.RTSP.Server.Handler","doc":"Behaviour describing client request handling for Real Time Streaming Protocol.\n\nIn a typical RTSP session where the client requests a media stream from a server, the\ninteractions goes as follows:\n\n```mermaid\nsequenceDiagram\n    participant C as Client\n    participant S as RTSP Server\n\n    C->>+S: connect to the server (rtsp://server_host:554/stream)\n    S->>-C: connection accepted\n\n    note right of C: Get supported methods\n    C->>+S: OPTIONS rtsp://server_host:554/stream\n    S->>-C: List of allowed methods\n\n    note right of C: Get the media description\n    C->>+S: DESCRIBE rtsp://server_host:554/stream\n    S->>-C: Media description (usually as an SDP)\n\n    note right of C: Setup the video\n    C->>+S: SETUP rtsp://server_host:554/stream/video\n    S->>-C: Video track setup (returns also a session id)\n\n    note right of C: Setup the audio\n    C->>+S: SETUP rtsp://server_host:554/stream/audio\n    S->>-C: Audio track setup\n\n    note right of C: Start playing the media\n    C->>+S: PLAY rtsp://server_host:554/stream/audio\n    S->>-C: Video/audio data are sent to the client via UDP, TCP or Multicast\n\n    note right of C: Stop and free the resources\n    C->>+S: TEARDOWN rtsp://server_host:554/stream/audio\n    S->>-C: Media streaming stopped and resources are freed\n```\n\nWe omitted other methods for brevity such as `GET_PARAMETER` where the client wants to keep the\nsession alive and `PAUSE` to pause streaming without freeing the resources used by the session.","ref":"Membrane.RTSP.Server.Handler.html"},{"type":"behaviour","title":"Response - Membrane.RTSP.Server.Handler","doc":"The handler is responsible for returning the right response and managing the media resources\nwhile the server will be responsible for parsing client request, calling the handler callbacks\nand forwarding the response to the client.\n\nExcept for `c:handle_describe/2` where the handler should return the media description (usually as an SDP),\nthe handler need only to set the response status using `Membrane.RTSP.Response.new/1`. In most cases\nthe handler should not try to set the headers itself except for `WWW-Authenticate` in case authentication\nusing `basic` or `digest` is required.","ref":"Membrane.RTSP.Server.Handler.html#module-response"},{"type":"behaviour","title":"State - Membrane.RTSP.Server.Handler","doc":"The handler may need to keep some state between the callback calls. To achieve this, the returned value from\n`c:handle_open_connection/1` callback will be used as a state and will be the last argument for the other callbacks.\n\n> #### `Missing callbacks in the handler` {: .info}\n>\n> You may notice that some methods have no corresponding callback, the reason for this is:\n>\n> `OPTIONS` apply to the server itself, not to individual presentation or resources\n>\n> `GET_PARAMETER` is used to keep the session alive and the server is responsible for setting session timeout\n>\n> The other methods are not yet implemented.","ref":"Membrane.RTSP.Server.Handler.html#module-state"},{"type":"callback","title":"Membrane.RTSP.Server.Handler.handle_closed_connection/1","doc":"Callback called when a connection is closed.\n\nA handler may not receive a `TEARDOWN` request to free resources, so it\ncan use this callback to do it.","ref":"Membrane.RTSP.Server.Handler.html#c:handle_closed_connection/1"},{"type":"callback","title":"Membrane.RTSP.Server.Handler.handle_describe/2","doc":"Callback called when receiving a DESCRIBE request.\n\nThe return value is the response to be sent back to the client. The implementing\nmodule need at least set the status of the response.","ref":"Membrane.RTSP.Server.Handler.html#c:handle_describe/2"},{"type":"callback","title":"Membrane.RTSP.Server.Handler.handle_open_connection/1","doc":"Callback called when a new connection is established.\n\nThe returned value is used as a state and is passed as the last argument to\nthe subsequent callbacks","ref":"Membrane.RTSP.Server.Handler.html#c:handle_open_connection/1"},{"type":"callback","title":"Membrane.RTSP.Server.Handler.handle_pause/1","doc":"Callback called when receiving a PAUSE request.\n\nUpon receiving a PAUSE request, the server should stop sending media data, however\nthe resources should not be freed. If the stream cannot be stopped (e.g. live view), this callback\nshould return `501` (Not Implemented) response.","ref":"Membrane.RTSP.Server.Handler.html#c:handle_pause/1"},{"type":"callback","title":"Membrane.RTSP.Server.Handler.handle_play/2","doc":"Callback called when receiving a PLAY request.\n\n`configured_media_context` contains the needed information to start sending media packets.\nRefer to the type documentation for more details","ref":"Membrane.RTSP.Server.Handler.html#c:handle_play/2"},{"type":"callback","title":"Membrane.RTSP.Server.Handler.handle_setup/2","doc":"Callback called when receiving a SETUP request.\n\nThe handler should check for the validity of the requested track (`path` field of the `Request` struct).","ref":"Membrane.RTSP.Server.Handler.html#c:handle_setup/2"},{"type":"callback","title":"Membrane.RTSP.Server.Handler.handle_teardown/1","doc":"Callback called when receiving TEARDOWN request.\n\nThe implementer should stop sending media packets and free resources used by\nthe session.","ref":"Membrane.RTSP.Server.Handler.html#c:handle_teardown/1"},{"type":"type","title":"Membrane.RTSP.Server.Handler.configured_media_context/0","doc":"A type representing the configured media context.\n\nThe type is a map from a control path to the setup details. Each track contains the\nfollowing information:\n  * `ssrc` - The synchronisation source to use in the `RTP` packets.\n  * `transport` - The transport used for carrying the media packets.\n  * `tcp_socket` - An already open socket to use to send muxed `RTP` and `RTCP` packets. Available only when transport is `TCP`.\n  * `channels` - A pair of channel numbers to include in the `RTP` and `RTCP` packets. Available only when transport is `TCP`\n  * `rtp_socket` - An already open socket to use to send `RTP` packets. Available only when transport is `UDP`.\n  * `rtcp_socket` - An already open socket to use to send `RTCP` packets. Available only when transport is `UDP`.\n  * `client_port` - A pair of ports to use to send `RTP` and `RTCP` packets respectively. Available only when transport is `UDP`\n  * `address` - An ip address where to send `RTP` and `RTCP` packets. Available only when transport is `UDP`","ref":"Membrane.RTSP.Server.Handler.html#t:configured_media_context/0"},{"type":"type","title":"Membrane.RTSP.Server.Handler.conn/0","doc":"","ref":"Membrane.RTSP.Server.Handler.html#t:conn/0"},{"type":"type","title":"Membrane.RTSP.Server.Handler.control_path/0","doc":"","ref":"Membrane.RTSP.Server.Handler.html#t:control_path/0"},{"type":"type","title":"Membrane.RTSP.Server.Handler.request/0","doc":"","ref":"Membrane.RTSP.Server.Handler.html#t:request/0"},{"type":"type","title":"Membrane.RTSP.Server.Handler.ssrc/0","doc":"","ref":"Membrane.RTSP.Server.Handler.html#t:ssrc/0"},{"type":"type","title":"Membrane.RTSP.Server.Handler.state/0","doc":"Any term that will be used to keep state between the callbacks.","ref":"Membrane.RTSP.Server.Handler.html#t:state/0"},{"type":"extras","title":"Membrane RTSP","doc":"# Membrane RTSP\n\n[![Hex.pm](https://img.shields.io/hexpm/v/membrane_rtsp.svg)](https://hex.pm/packages/membrane_rtsp)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/membrane_rtsp/)\n[![CircleCI](https://circleci.com/gh/membraneframework/membrane_rtsp.svg?style=svg)](https://circleci.com/gh/membraneframework/membrane_rtsp)\n\n\nThe RTSP client for Elixir\n\nCurrently supports only RTSP 1.1 defined by\n[RFC2326](https://tools.ietf.org/html/rfc2326)","ref":"readme.html"},{"type":"extras","title":"Installation - Membrane RTSP","doc":"The package can be installed by adding `membrane_rtsp` to your list\nof dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:membrane_rtsp, \"~> 0.7.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Membrane RTSP","doc":"To use the Membrane RTSP client you must first start a session:\n\n```elixir\n{:ok, session} = Membrane.RTSP.start_link(\"rtsp://domain.name:port/path\")\n```\n\nThen you can proceed with executing requests:\n\n```elixir\nalias Membrane.RTSP\nalias Membrane.RTSP.Response\n\n{:ok, %Response{status: 200}} = RTSP.describe(session)\n\n{:ok, %Response{status: 200}} =\n  RTSP.setup(session, \"/trackID=1\", [\n    {\"Transport\", \"RTP/AVP;unicast;client_port=57614-57615\"}\n  ])\n\n{:ok, %Response{status: 200}} =\n  RTSP.setup(session, \"/trackID=2\", [\n    {\"Transport\", \"RTP/AVP;unicast;client_port=52614-52615\"}\n  ])\n\n{:ok, %Response{status: 200}} = RTSP.play(session)\n```\n\nIf you started a session without linking it, it is advised to close it manually\nby calling:\n\n```elixir\nRTSP.close(session)\n```","ref":"readme.html#usage"},{"type":"extras","title":"External tests - Membrane RTSP","doc":"Tests that use external RTSP service are disabled by default but they are present\nin the codebase. They are tagged as external and are usually accompanied by\ntests that mimic their behavior by using predefined responses.","ref":"readme.html#external-tests"},{"type":"extras","title":"Copyright and License - Membrane RTSP","doc":"Copyright 2019, [Software Mansion](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane)\n\n[![Software Mansion](https://logo.swmansion.com/logo?color=white&variant=desktop&width=200&tag=membrane-github)](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane)\n\nLicensed under the [Apache License, Version 2.0](LICENSE)","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"Basic Server","doc":"# Basic Server\n\n```elixir\nMix.install([\n  {:membrane_core, \"~> 1.0.0\"},\n  {:membrane_rtsp, \"~> 0.6.0\"},\n  {:membrane_rtp_plugin, \"~> 0.24.0\"},\n  {:membrane_rtp_h264_plugin, \"~> 0.19.0\"},\n  {:membrane_h264_plugin, \"~> 0.9\"},\n  {:membrane_file_plugin, \"~> 0.16.0\"},\n  {:membrane_realtimer_plugin, \"~> 0.9.0\"}\n])\n```","ref":"basic_server.html"},{"type":"extras","title":"Introduction - Basic Server","doc":"In this guide, we'll create a simple RTSP server that streams an H264 file to clients via UDP and TCP\n\nBefore we start the server itself, we'll first create the Membrane pipeline that will serve the H264 file.","ref":"basic_server.html#introduction"},{"type":"extras","title":"TCP/UDP Sink - Basic Server","doc":"To serve media data to the client over the same connection used for controlling the session, we need to create a TCP payloader sink \nto wrap the RTP packets as described in [RFC 2326 Section 10.12](https://www.rfc-editor.org/rfc/rfc2326#page-40)\n\n```elixir\ndefmodule BasicServer.TCP.Sink do\n  @moduledoc false\n\n  use Membrane.Sink\n\n  def_input_pad(:input, accepted_format: _any, availability: :on_request)\n\n  def_options(socket: [spec: :inet.socket()])\n\n  @impl true\n  def handle_init(_ctx, opts) do\n    {[], %{socket: opts.socket}}\n  end\n\n  @impl true\n  def handle_buffer(Pad.ref(:input, channel), buffer, _ctx, state) do\n    :gen_tcp.send(\n      state.socket,\n      <<0x24::8, channel::8, byte_size(buffer.payload)::16, buffer.payload::binary>>\n    )\n\n    {[], state}\n  end\nend\n```\n\nAnd we'll need another sink to send data using an open UDP socket\n\n```elixir\ndefmodule BasicServer.UDP.Sink do\n  @moduledoc false\n\n  use Membrane.Sink\n\n  def_input_pad(:input, accepted_format: _any)\n\n  def_options(\n    socket: [spec: :inet.socket()],\n    address: [spec: :inet.ipaddress()],\n    port: [spec: :inet.port_number()]\n  )\n\n  @impl true\n  def handle_init(_ctx, opts) do\n    {[], %{socket: opts.socket, address: opts.address, port: opts.port}}\n  end\n\n  @impl true\n  def handle_buffer(:input, buffer, _ctx, state) do\n    :gen_udp.send(state.socket, state.address, state.port, buffer.payload)\n    {[], state}\n  end\nend\n```","ref":"basic_server.html#tcp-udp-sink"},{"type":"extras","title":"Pipeline - Basic Server","doc":"```elixir\ndefmodule BasicServer.Pipeline do\n  use Membrane.Pipeline\n\n  require Membrane.Logger\n\n  def start(options) do\n    Membrane.Pipeline.start(__MODULE__, options)\n  end\n\n  @impl true\n  def handle_init(_ctx, options) do\n    Membrane.Logger.info(\"\"\"\n    Start the pipeline with the following config\n    #{inspect(options)}\n    \"\"\")\n\n    spec =\n      child(:source, %Membrane.File.Source{location: options[:file_location]})\n      |> child(:parser, %Membrane.H264.Parser{\n        generate_best_effort_timestamps: %{framerate: {60, 1}},\n        output_stream_structure: :annexb,\n        output_alignment: :nalu\n      })\n      |> child(:realtimer, Membrane.Realtimer)\n      |> via_in(Pad.ref(:input, options[:ssrc]),\n        options: [payloader: Membrane.RTP.H264.Payloader]\n      )\n      |> child(:session_bin, Membrane.RTP.SessionBin)\n      |> via_out(Pad.ref(:rtp_output, options[:ssrc]),\n        options: [payload_type: options[:payload_type], clock_rate: options[:clock_rate]]\n      )\n      |> build_sink(options)\n\n    {[spec: spec], %{}}\n  end\n\n  defp build_sink(link_builder, options) do\n    if options[:transport] == :TCP do\n      link_builder\n      |> via_in(Pad.ref(:input, elem(options.channels, 0)))\n      |> child(:sink, %BasicServer.TCP.Sink{socket: options[:tcp_socket]})\n    else\n      link_builder\n      |> child(:sink, %BasicServer.UDP.Sink{\n        socket: options[:rtp_socket],\n        address: options[:address],\n        port: elem(options[:client_port], 0)\n      })\n    end\n  end\nend\n```","ref":"basic_server.html#pipeline"},{"type":"extras","title":"RTSP Request Handler - Basic Server","doc":"Now we need to implement the `Membrane.RTSP.Server.Handler` behaviour\n\n```elixir\ndefmodule BasicServer.RequestHandler do\n  @moduledoc false\n\n  @behaviour Membrane.RTSP.Server.Handler\n\n  require Logger\n\n  alias Membrane.RTSP.Response\n\n  @url \"rtsp://localhost:8554/mystream\"\n  @file_path \"./file.h264\"\n\n  @impl true\n  def handle_open_connection(conn) do\n    {:ok, {address, port}} = :inet.peername(conn)\n    Logger.info(\"New connection from #{:inet.ntoa(address)}:#{port}\")\n\n    %{\n      control_path: @url <> \"/video\",\n      config: %{payload_type: 96, clock_rate: 90_000},\n      pipeline_pid: nil\n    }\n  end\n\n  @impl true\n  def handle_describe(req, state) do\n    Logger.info(\"Handle DESCRIBE request\")\n\n    if req.path == @url do\n      video_config = state[:config]\n\n      sdp = ExSDP.new(session_name: \"MySession\")\n\n      sdp =\n        ExSDP.Media.new(:video, 0, \"RTP/AVP\", \"#{video_config.payload_type}\")\n        |> ExSDP.add_attribute([\n          {\"control\", @url <> \"/video\"},\n          %ExSDP.Attribute.RTPMapping{\n            clock_rate: video_config.clock_rate,\n            payload_type: video_config.payload_type,\n            encoding: :H264\n          }\n        ])\n        |> then(&ExSDP.add_media(sdp, &1))\n\n      Response.new(200)\n      |> Response.with_header(\"Content-Type\", \"application/sdp\")\n      |> Response.with_body(to_string(sdp))\n      |> then(&{&1, state})\n    else\n      {Response.new(400), state}\n    end\n  end\n\n  @impl true\n  def handle_setup(req, state) do\n    Logger.info(\"Handle SETUP request: #{req.path}\")\n\n    if req.path == state[:control_path] do\n      {Response.new(200), state}\n    else\n      {Response.new(400), state}\n    end\n  end\n\n  @impl true\n  def handle_play(configured_media_context, state) do\n    Logger.info(\"\"\"\n    Handle PLAY request, starting the pipeline\n    config: #{inspect(configured_media_context)}\n    \"\"\")\n\n    options =\n      configured_media_context[state.control_path]\n      |> Map.merge(state[:config])\n      |> Map.put(:file_location, @file_path)\n\n    {:ok, _sup_pid, pipeline_pid} = BasicServer.Pipeline.start(options)\n\n    {Response.new(200), %{state | pipeline_pid: pipeline_pid}}\n  end\n\n  @impl true\n  def handle_pause(state) do\n    {Response.new(501), state}\n  end\n\n  @impl true\n  def handle_teardown(state) do\n    Logger.info(\"Handle TEARDOWN request, stopping the pipeline\")\n    Membrane.Pipeline.terminate(state.pipeline_pid)\n    {Response.new(200), %{state | pipeline_pid: nil}}\n  end\n\n  @impl true\n  def handle_closed_connection(state) do\n    Logger.info(\"Connection closed\")\n\n    if pid = state.pipeline_pid do\n      Membrane.Pipeline.terminate(pid)\n    end\n\n    :ok\n  end\nend\n```\n\nNow we can start the server\n\n```elixir\nMembrane.RTSP.Server.start_link(\n  handler: BasicServer.RequestHandler,\n  port: 8554,\n  udp_rtp_port: 5000,\n  udp_rtcp_port: 5001\n)\n```","ref":"basic_server.html#rtsp-request-handler"},{"type":"extras","title":"Testing the server - Basic Server","doc":"Now that the server is started, we can try it by using `ffplay` or `vlc`.\n\n```\nffplay -i \"rtsp://localhost:8554/mystream\"\n```\n\nOr request the media via TCP\n\n```\nffplay -rtsp_transport tcp -i \"rtsp://localhost:8554/mystream\"\n```","ref":"basic_server.html#testing-the-server"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2018 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"content_type":"text/markdown"}